/*

    Copyright 2004,2005,2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt

*/

#include <stdio.h>
#include <stdlib.h>
#include "totalsims_xtea.h"
#include "show_dump.h"



#define VER     "0.1"
#define BUFFSZ  128



void std_err(void);



int main(int argc, char *argv[]) {
    FILE            *fd;
    unsigned int   key;
    int             len;
    unsigned char   buff[BUFFSZ];


    setbuf(stdout, NULL);

    fputs("\n"
        "TotalSims games offline login password decrypter "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 3) {
        printf("\n"
            "Usage: %s <server_dump> <client_dump>\n"
            "\n"
            "With server_dump I mean the first TCP data sent from the server\n"
            "arnalist.warbirdsiii.com:19243 when your client wants to go online.\n"
            "This data is 32 bytes long.\n"
            "\n"
            "Instead with client_dump I mean the data sent by your client after having\n"
            "received the server's data. This data is 96 bytes long, do NOT include the\n"
            "2 bytes (01 00) that the client sends to the server before the 96 bytes data.\n"
            "\n"
            "Both the 2 files must contain the TCP data only NOT the whole packet!\n"
            "\n", argv[0]);
        exit(1);
    }

    printf("- open server_dump file \"%s\"\n", argv[1]);
    fd = fopen(argv[1], "rb");
    if(!fd) std_err();

    fread(buff, 32, 1, fd); // no length check, too lazy
    fclose(fd);

    key = totalsims_getkey(buff);
    printf("- encryption key:  0x%08x\n", key);

    printf("- open client_dump file \"%s\"\n", argv[2]);
    fd = fopen(argv[2], "rb");
    if(!fd) std_err();

    len = fread(buff, 1, BUFFSZ, fd);
    fclose(fd);

    totalsims_xtea_dec(buff, len, key);
    fputs("- hex dump of the decrypted login data:\n\n", stdout);
    show_dump(buff, len, stdout);

    return(0);
}



void std_err(void) {
    perror("\nError");
    exit(1);
}

